﻿using System;
using System.Windows;
using System.IO;
using System.ComponentModel;
using System.Threading;

namespace TravelBuddy
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {  

        //Create a separate thread for updating the GUI
        private readonly BackgroundWorker bw = new BackgroundWorker();
        //Create array to store data from text file
        public string[] aryTextValues = new string [100];
        //Create thread flag
        public bool boolRunning = false;

        public MainWindow()
        {
            InitializeComponent();
            //Define the handlers for the functions required by the separate thread
            bw.DoWork += bw_DoWork;
            bw.RunWorkerCompleted += bw_RunWorkerCompleted;
            bw.WorkerSupportsCancellation = true;
            //Clear out the output, I'm too lazy to do this in the designer
            this.txtLine1.Text = "";
            this.txtLine2.Text = "";
            this.txtLine3.Text = "";
            this.txtLine4.Text = "";
            this.txtLine5.Text = "";
        }

        //This is the function that executes when the background worker thread is called (asynchronous)
        void bw_DoWork(object sender, DoWorkEventArgs e)
        {
            Thread.Sleep(1000);
            if (boolRunning == true)
            {
                //Define the sender as a return to the caller
                BackgroundWorker bw = (BackgroundWorker)sender;
                //Declare a new file read process
                StreamReader sr = new StreamReader(@"C:\sw3dg\EvochronMercenary\savedata.txt");
                //Declare an index for the array to increment during file read
                int intIndex = 0;
                //Use PEEK to check for end of file, read each line and write it to the array, trimming white space from the ends
                while (sr.Peek() != -1)
                {
                    aryTextValues[intIndex] = sr.ReadLine().Trim();
                    intIndex++;
                }
                //Close the file
                sr.Close();
            }
            else
            {
                bw.CancelAsync();
            }
        }

        //This is the function that executes when the background worker thread reaches its end
        void bw_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
        {
            if (boolRunning == true)
            {
                //Initialize variables for the calculations
                double dblEngine = 0;
                double dblMilage = 0;
                double dblRange = 0;
                //Check for Inertia control - line 84 - 0 base array so index is 83
                if (aryTextValues[83] == "1")
                {
                    //Set the foreground color of the text block
                    this.txtLine1.Foreground = System.Windows.Media.Brushes.Cyan;
                    //Set the text of the text block
                    this.txtLine1.Text = "Inertial Mode Activated";
                }
                else
                {
                    //Set the foreground color of the text block
                    this.txtLine1.Foreground = System.Windows.Media.Brushes.Red;
                    //Set the text of the text block
                    this.txtLine1.Text = "Warning: IDS Engaged!";
                }
                //Check for energy settings - line 82 - 0 base array so index is 81
                if (aryTextValues[81] == "-5S/5W")
                {
                    //Set the foreground color of the text block
                    this.txtLine2.Foreground = System.Windows.Media.Brushes.Cyan;
                    //Set the text of the text block
                    this.txtLine2.Text = "Energy Bias Set: -5S/5W";
                }
                else
                {
                    //Set the foreground color of the text block
                    this.txtLine2.Foreground = System.Windows.Media.Brushes.Red;
                    //Set the text of the text block
                    this.txtLine2.Text = "Warning: Energy Bias Not -5S/5W!";
                }
                //Create a flag in case there is no jump drive
                bool boolDrive = false;
                //Check for jump drives in lines 51-58 - 0 base array so indices 50-57
                for (int x = 50; x < 58; x++)
                {
                    //Use a case structure to check for the following drives, assign milage and engine values - if a drive is found, flag the boolean as true
                    switch (aryTextValues[x])
                    {
                        case "Mantis Jump Drive":
                            dblEngine = 38.990761;
                            dblMilage = 39.143333;
                            boolDrive = true;
                            break;
                        case "Fulcrum Drive C5":
                            dblEngine = 19.639794;
                            dblMilage = 19.768439;
                            boolDrive = true;
                            break;
                        case "Fulcrum Drive C4":
                            dblEngine = 16.019498;
                            dblMilage = 16.135822;
                            boolDrive = true;
                            break;
                        case "Fulcrum Drive C3":
                            dblEngine = 11.875259;
                            dblMilage = 11.916839;
                            boolDrive = true;
                            break;
                        case "Fulcrum Drive C2":
                            dblEngine = 7.964197;
                            dblMilage = 7.997451;
                            boolDrive = true;
                            break;
                        default:
                            //No drive found, do nothing - this prevents us from overwriting a "found" status when we're reading a line after the drive we found
                            break;
                    }
                }
                //Determine the length of the string for range - line 83, index 82
                int intCharacters = aryTextValues[82].Length;
                //Create a flag for remaining number of sectors - if we start and there are no more than 1 sector, skip the calculations
                bool boolMoreThan1Sector = false;
                //Check each character of the range string for number of sectors
                for (int intSub = 0; intSub < intCharacters; intSub++)
                {
                    //Check for S in the range for number of sectors
                    if (aryTextValues[82].Substring(intSub, 1) == "S")
                    {
                        //Pull the range from the string (values before the S)
                        dblRange = Convert.ToDouble(aryTextValues[82].Substring(0, intSub));
                        //If there's more than 1 sector distance, set the flag
                        if (dblRange > 1)
                        {
                            boolMoreThan1Sector = true;
                        }
                        //If there are more than 10 sectors to go, perform trip calculations
                        if (dblRange > 10)
                        {
                            //Set the text of the text block
                            this.txtLine3.Text = "Range to Destination: " + dblRange.ToString() + " sectors";
                            //Only do the calculations if there's a jump drive
                            if (boolDrive == true)
                            {
                                //Determine Estimated Time Enroute
                                double dblETE = dblRange / dblEngine;
                                double dblEslop = dblETE * .03986135;
                                //Determine fuel consumption
                                double dblFuel = dblETE * dblMilage;
                                double dblFslop = dblFuel * .04311414;
                                //Check if more than 1 minute is remaining in the trip
                                if (Math.Round(dblETE) > 0)
                                {
                                    //Set the text of the text block
                                    this.txtLine4.Text = "Time Enroute: " + Math.Round(dblETE).ToString() + " +/- " + Math.Round(dblEslop).ToString() + " minutes";
                                }
                                else
                                {
                                    //Set the text of the text block
                                    this.txtLine4.Text = "Time Enroute: Less than 1 minute";
                                }
                                //Set the text of the text block
                                this.txtLine5.Text = "Fuel Consumption: " + Math.Round(dblFuel).ToString() + " +/- " + Math.Round(dblFslop).ToString() + " units";
                            }
                        }
                        else if (dblRange <= 10 && Convert.ToDouble(aryTextValues[94]) < 10000)
                        {
                            //Set the text of the text blocks
                            this.txtLine3.Text = "Range to Jump Point: " + dblRange.ToString() + " sectors";
                            this.txtLine4.Text = "";
                            this.txtLine5.Text = "";
                        }
                    }
                }
                //If there are fewer than 2 sectors of distance, display the generic message
                if (boolMoreThan1Sector == false)
                {
                    //Set the text of the text block
                    this.txtLine3.Text = "";
                    this.txtLine4.Text = "";
                    this.txtLine5.Text = "";
                    //Add audio end-of-trip reminder
                    Console.Beep();
                }
                //Check to make sure the program isn't paused, if it isn't, call the thread to do it all over again
                if (btnInit.IsEnabled == false)
                {
                    bw.RunWorkerAsync();
                }
            }
            else
            {
                //Set the text of the text block
                this.txtLine1.Text = "";
                this.txtLine2.Text = "";
                this.txtLine3.Text = "";
                this.txtLine4.Text = "";
                this.txtLine5.Text = "";
            }   
        }

        //This is the function that executes when you click the INIT button on the GUI
        private void btnInit_Click(object sender, RoutedEventArgs e)
        {
            //Disable the INIT button, if you let someone click it again it'll crash trying to recreate the same thread
            btnInit.IsEnabled = false;
            boolRunning = true;
            //Call the backgroundworker thread to action
            bw.RunWorkerAsync();
        }

        //This is the function that executes when you click the PAUSE button on the GUI
        private void btnPause_Click(object sender, RoutedEventArgs e)
        {
            //Re-enable the INIT button (resume)
            btnInit.IsEnabled = true;
            boolRunning = false;
        }

        //This is the function that executes when you click the EXIT button on the GUI
        private void btnExit_Click(object sender, RoutedEventArgs e)
        {
            //Stop the background thread
            boolRunning = false;
            //Close the program
            this.Close();
        }

        //This is the function that executes when you drag the window
        private void window_MoveWindow(object sender, RoutedEventArgs e)
        {
            //Reposition the window
            DragMove();
        }
        //This function increases the window opacity
        private void btnOpacityPlus_Click(object sender, RoutedEventArgs e)
        {
            if(this.Opacity < 1) this.Opacity += 0.10;
        }
        //This function decreases the window opacity
        private void btnOpacityMinus_Click(object sender, RoutedEventArgs e)
        {
            if(this.Opacity > 0.19) this.Opacity -= 0.1;
        }
    }
}
